﻿
using System;
using HeuristicLab.Hive;
namespace HeuristicLab.Clients.Hive.SlaveCore {
  [Serializable]
  public enum ExecutorMessageType {
    JobStarted,
    JobPaused,
    JobStopped,
    JobFailed,
    NewChildJob,
    WaitForChildJobs,
    DeleteChildJobs,
    StopExecutorMonitoringThread
  }

  [Serializable]
  public class ExecutorMessage {
    public ExecutorMessageType MessageType { get; set; }

    public ExecutorMessage(ExecutorMessageType messageType) {
      MessageType = messageType;
    }
  }

  [Serializable]
  public class JobExecutorMessage : ExecutorMessage {
    public IJob Job { get; private set; }

    public JobExecutorMessage(ExecutorMessageType messageType, IJob job) : base(messageType) {
      this.Job = job;
    }
  }
}
